Program set_VGAMODE;

{ Copuright Tomi Engdahl 1886

  usage: VGAMODE modenumber

}

Uses Dos;

Function read_video_mode:byte;
Var
   reg:registers;
Begin
   reg.ah:=$0f;
   Intr($10,reg);
   read_video_mode:=reg.al;
End;

Procedure set_video_mode(modenum:byte);
Var
   reg:registers;
Begin
   reg.ah:=$00;
   reg.al:=modenum;
   Intr($10,reg);
End;

Var
   reg:registers;
   number:integer;
   i:integer;

Begin
   If ParamCount<1 Then Begin
      Writeln('VGA card is currently in mode ',read_video_mode);
      Writeln('Usage: VGAMODE modenumber');
      Halt;
   End;
   Val(ParamStr(1),number,i);
   If i<>0 Then Begin
      Writeln('Invalid numeric format.');
      Writeln('Use descimal or hexadecimal preceeded by $');
      Halt;
   End;
   If (number<0) or (number>255) Then Begin
      Writeln('Numeric value out of range.');
      Halt;
   End;
   set_video_mode(number);
   Writeln('VGAMODE program version 0.2 Copyright Tomi Engdahl 1996');
   Writeln('Current screen mode is ',read_video_mode);
End.
